#ifndef _VIDEO_DRV_H_
#define _VIDEO_DRV_H_

typedef struct {
          int width,height;
          short bit;
          unsigned short mode;
          unsigned short special_func;
        } video_mode_type;

typedef struct {
          unsigned short win_segment;
          unsigned short flat_selector;
          int win_shift;
          int bytes_per_line;
          unsigned char pixel_order;
        } video_mode_info_type;

typedef struct {
          int major_version,minor_version;
          int memory_size;
          char have_flat_model,protected_mode_switch;
        } video_info_type;

typedef struct {
          int (*video_init)(unsigned int dos_tb,unsigned int dos_ds,
                            int (*dpmi_int)(int, ...),
                            void *(*_malloc)(size_t), void (*_free)(void *),
                            void (*_qsort)(void *, ...),
                            void *(*_bsearch)(void *, ...));
          void (*video_get_table)(video_mode_type **graphic_mode_table,
                                  video_mode_type **text_mode_table);
          void (*video_get_info)(video_info_type *info);
	  void (*video_deinit)(void);
	  void (*video_set_option)(int need_flat,int protected_mode_switch);
	  int (*video_change_bank)(int bank);
          int (*video_next_bank)(void);
	  int (*video_current_bank)(void);
	  video_mode_info_type *(*video_set_mode)(int is_graphic,int width,
                                                  int height,int bit);
        } video_func_type;


/*
  Used in other files
*/
extern int (*video_init)(unsigned int dos_tb,unsigned int dos_ds,
                         int (*dpmi_int)(int, ...),
                         void *(*_malloc)(size_t), void (*_free)(void *),
                         void (*_qsort)(void *, ...),
                         void *(*_bsearch)(void *, ...));
extern void (*video_get_table)(video_mode_type **graphic_mode_table,
                               video_mode_type **text_mode_table);
extern void (*video_get_info)(video_info_type *info);
extern void (*video_deinit)(void);
extern void (*video_set_option)(int need_flat,int protected_mode_switch);
extern int (*video_change_bank)(int bank);
extern int (*video_next_bank)(void);
extern int (*video_current_bank)(void);
extern video_mode_info_type *(*video_set_mode)(int is_graphic,int width,
                                               int height,int bit);


#endif